

package gram.engine.input;

import com.threed.jpct.FrameBuffer;
import com.threed.jpct.util.KeyMapper;
import com.threed.jpct.util.KeyState;
import java.awt.event.KeyEvent;
import org.lwjgl.input.Mouse;

/**
 *
 * @author Ruslan Nevedomy
 * @site jpct.ucoz.ru
 */
public class InputMap {
    
    public int mouse_x;
    public int mouse_y;
    
    public boolean mouse_leftbutton_down = false;
    public boolean mouse_rigthbutton_down = false;
    
    public int numeric_key=-1;
    public boolean space_key = false;
        
    private KeyMapper keyMapper;
    private FrameBuffer buffer;
       
    public InputMap(FrameBuffer buffer)
    {
        keyMapper = new KeyMapper();
        this.buffer = buffer;        
    }
            
    public void evaluteInput()
    {
        KeyState ks;
        //Обработка клавиатуры
         while( ( ks = keyMapper.poll() ) != KeyState.NONE ) 
         {             
             switch (ks.getKeyCode())
             {                
                 //пример Обработки ввода цифр на основной клавиатуре
                 case KeyEvent.VK_0:        {numeric_key = 0;continue;}
                
                 //обработка пробела
                 case KeyEvent.VK_SPACE:    {space_key = ks.getState(); continue;}                     
             }             
         }
         //Обработка мыши         
         //получение координат мыши
         mouse_x = Mouse.getX();
         //не забываем про инверсию по Y
         mouse_y = buffer.getOutputHeight()-Mouse.getY();
         //чтение состояния кнопок мыши
         if (Mouse.isButtonDown(0))
         {
             mouse_leftbutton_down = true;
         }
         else
         {
             mouse_leftbutton_down = false;
         }
         if (Mouse.isButtonDown(1))
         {
             mouse_rigthbutton_down = true;
         }
         else
         {
             mouse_rigthbutton_down = false;
         }
    }
}
